
$INCLUDE(STC32G.INC)

;************************************************
    
    DEVSTATE_ATTACHED       EQU     0
    DEVSTATE_POWERED        EQU     1
    DEVSTATE_DEFAULT        EQU     2
    DEVSTATE_ADDRESS        EQU     3
    DEVSTATE_CONFIGURED     EQU     4
    DEVSTATE_SUSPENDED      EQU     5
    
    EXTRN   ECODE(USB_INIT?)
    EXTRN   ECODE(USB_OUT_DONE?)
    EXTRN   ECODE(USB_SENDDATA?)
    EXTRN   ECODE(SET_USB_OUT_CALLBACK?)
	EXTRN   ECODE(SET_USB_IN_CALLBACK?)

    EXTRN   EDATA(DEVICESTATE)
    EXTRN   EDATA(USER_STCISPCMD)

    EXTRN   BIT(BUSBFEATUREREADY)
    EXTRN   BIT(BUSBINBUSY)
    EXTRN   BIT(BUSBOUTREADY)
    EXTRN   XDATA(USBFEATUREBUFFER)
    EXTRN   XDATA(USBINBUFFER)
    EXTRN   XDATA(USBOUTBUFFER)
    

;************************************************


;************************************************

    CSEG    AT  0000H
    LJMP    RESET                       ;λת

;************************************************

?PR?MAIN    SEGMENT CODE                ;
    RSEG    ?PR?MAIN
RESET:
    MOV     R0,#7FH
    CLR     A
CLEARRAM:
    MOV     @R0,A
    DJNZ    R0,CLEARRAM
    
    MOV     DR60,#0100H

    MOV     WTST,#00H
    MOV     CKCON,#00H
    SETB    EAXFR

    CLR     A
    MOV     P0M0,A
    MOV     P0M1,A
    MOV     P1M0,A
    MOV     P1M1,A
    MOV     P2M0,A
    MOV     P2M1,A
    MOV     P3M0,A
    MOV     P3M1,A
    MOV     P4M0,A
    MOV     P4M1,A
    MOV     P5M0,A
    MOV     P5M1,A
    MOV     P6M0,A
    MOV     P6M1,A
    MOV     P7M0,A
    MOV     P7M1,A

	SUB     DR0,DR0
	ECALL   SET_USB_OUT_CALLBACK?

	SUB     DR0,DR0
	ECALL   SET_USB_IN_CALLBACK?

    MOV     WR0,#WORD2 TAB_STCISPCMD
    MOV     WR2,#WORD0 TAB_STCISPCMD
    MOV     USER_STCISPCMD,DR0          ;ʼͣظλ


    ECALL   USB_INIT?                   ;ʼUSBģ
    
    SETB    EA

WAITUSBCFG:
    MOV     R11,DEVICESTATE             ;ȴUSB
    CJNE    A,#DEVSTATE_CONFIGURED,WAITUSBCFG
    
MAIN:
    JNB     BUSBOUTREADY,MAIN           ;ѯǷнյ
    
    MOV     WR0,#WORD2 USBOUTBUFFER
    MOV     WR2,#WORD0 USBOUTBUFFER
    MOV     WR6,#0040H
    ECALL   USB_SENDDATA?               ;ԭ·
 
    ECALL   USB_OUT_DONE?               ;յݴɺٵô˺
    
    JMP     MAIN

;************************************************

TAB_STCISPCMD:
    DB      "@STCISP#",0

;************************************************

    END
